#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <string.h>

#include "mn2fw.h"
#include "mn2kbd.h"

/*
 * Keyboard interface
 */
#define KEY1_PORT   PORTC
#define KEY1_PIN    PINC
#define KEY1_DDR    DDRC
#define KEY1_BIT    4

#define KEY2_PORT   PORTB
#define KEY2_PIN    PINB
#define KEY2_DDR    DDRB
#define KEY2_BIT    1

#define KEY3_PORT   PORTB
#define KEY3_PIN    PINB
#define KEY3_DDR    DDRB
#define KEY3_BIT    0

#define KEY4_PORT   PORTC
#define KEY4_PIN    PINC
#define KEY4_DDR    DDRC
#define KEY4_BIT    5

unsigned char kbd_code;
static unsigned char old_code;

void Mn2KeyboardInit(void)
{
    KEY1_DDR &= ~(1 << KEY1_BIT);
    KEY1_PORT |= (1 << KEY1_BIT);

    KEY2_DDR &= ~(1 << KEY2_BIT);
    KEY2_PORT |= (1 << KEY2_BIT);

    KEY3_DDR &= ~(1 << KEY3_BIT);
    KEY3_PORT |= (1 << KEY3_BIT);

    KEY4_DDR &= ~(1 << KEY4_BIT);
    KEY4_PORT |= (1 << KEY4_BIT);
}

void Mn2KeyboardScan(void)
{
    if (kbd_code == 0) {
        if ((KEY1_PIN & (1 << KEY1_BIT)) == 0) {
            kbd_code |= 0x01;
        }
        if ((KEY2_PIN & (1 << KEY2_BIT)) == 0) {
            kbd_code |= 0x02;
        }
        if ((KEY3_PIN & (1 << KEY3_BIT)) == 0) {
            kbd_code |= 0x04;
        }
        if ((KEY4_PIN & (1 << KEY4_BIT)) == 0) {
            kbd_code |= 0x08;
        }
        if (kbd_code && old_code == 0) {
            kbd_code |= 0x80;
        }
        old_code = kbd_code;
    }
}
