#ifndef MN2LCD_H_
#define MN2LCD_H_

// HD44780 Commandset
#define LCD_CMD_CLR             0x01      // DB0: clear display

#define LCD_CMD_HOME            0x02      // DB1: return to home position

#define LCD_CMD_ENTRY_MODE      0x04      // DB2: set entry mode
#define LCD_CMD_ENTRY_SHIFT     0x01      //   DB2: shift
#define LCD_CMD_ENTRY_INC       0x02      //   DB1: increment

#define LCD_CMD_ON_CTRL         0x08      // DB3: turn lcd/cursor on
#define LCD_CMD_ON_BLINK        0x01      //   DB0: blinking cursor
#define LCD_CMD_ON_CURSOR       0x02      //   DB1: turn cursor on
#define LCD_CMD_ON_DISPLAY      0x04      //   DB2: turn display on

#define LCD_CMD_MOVE            0x10      // DB4: move cursor/display
#define LCD_CMD_MOVE_RIGHT      0x04      //   DB2: move right (0-> left)
#define LCD_CMD_MOVE_DISP       0x08      //   DB3: move display (0-> move cursor)

#define LCD_CMD_FUNCTION        0x20      // DB5: function set
#define LCD_CMD_FUNCTION_REV    0x01      //   DB0: Reverse Display
#define LCD_CMD_FUNCTION_DS     0x02      //   DB1: DisplayShift / DotScroll
#define LCD_CMD_FUNCTION_10DOTS 0x04      //   DB2: 5x10 font (0->5x7 font)
#define LCD_CMD_FUNCTION_RE     0x04      //   DB2: KS0073 Controller: Extended Register
#define LCD_CMD_FUNCTION_2LINES 0x08      //   DB3: two lines (0->one line)
#define LCD_CMD_FUNCTION_8BIT   0x10      //   DB4: set 8BIT mode (0->4BIT mode)

#define LCD_CMD_EXT             0x08      // DB3: Extended Register Set
#define LCD_CMD_EXT_4LINES      0x01      //   DB0: 1/2 Lines (normal) or 4Lines
#define LCD_CMD_EXT_INVCURS     0x02      //   DB1: Normal / Inverted Cursor
#define LCD_CMD_EXT_FONT        0x04      //   DB2: Fontwidth: 5 / 6 Pixel

#define LCD_CMD_CGRAM           0x40      // DB6: set CG RAM address

#define LCD_CMD_DDRAM           0x80      // DB7: set DD RAM address
// reading:
#define LCD_CMD_BUSY            0x80      // DB7: LCD is busy


extern int LcdInit(unsigned char mode);
extern int LcdSetPos(unsigned char row, unsigned char col);
extern void LcdUpdate(void);
extern void LcdWaitReady(void);
extern unsigned char LcdReadStatus(void);
extern void LcdWriteData(unsigned char);
extern void LcdWriteCmd(unsigned char);


#endif
